﻿using System;
using System.ComponentModel;

namespace WpfApplication1.Model
{
  /// <summary>
  /// Person representation, supporting notifications
  /// </summary>
  public class Person : INotifyPropertyChanged
  {
    private string _name;
    public string Name
    {
      get { return _name; }
      set
      {
        if (value != _name)
        {
          _name = value;
          OnPropertyChanged("Name");
        }
      }
    }

    public event PropertyChangedEventHandler PropertyChanged;

    protected void OnPropertyChanged(String propertyName)
    {
      var handler = PropertyChanged;
      if (handler != null)
      {
        handler(this, new PropertyChangedEventArgs(propertyName));
      }
    }

    public override string ToString()
    {
      return Name;
    }
  }
}
